<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__lpautilities" kind="group">
    <compoundname>lpautilities</compoundname>
    <title>LPA Utilities API</title>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__lpautilities_1ga8fe3dbb6666cb69c052385ce9ff9405f" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>int32_t</type>
        <definition>int32_t wait_net_suspend</definition>
        <argsstring>(void *net_intf, uint32_t wait_ms, uint32_t inactive_interval_ms, uint32_t inactive_window_ms)</argsstring>
        <name>wait_net_suspend</name>
        <param>
          <type>void *</type>
          <declname>net_intf</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>wait_ms</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>inactive_interval_ms</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>inactive_window_ms</declname>
        </param>
        <briefdescription>
<para>Network Monitor Function. </para>        </briefdescription>
        <detaileddescription>
<para>In this function the network is monitored for inactivity in an interval of length inactive_interval_ms. If the network is inactive for a continuous duration specified by inactive_window_ms, the TCP/IP network stack is suspended and stays suspended until either there is emac activity or a duration of wait_ms has expired. Network stack is resumed on either detecting emac activity or if wait_ms time has elapsed.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>*net_intf</parametername>
</parameternamelist>
<parameterdescription>
<para>: pointer to WLAN interface </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>wait_ms</parametername>
</parameternamelist>
<parameterdescription>
<para>: The interval for which the network is monitored for activity. Network stack is resumed ether at the end of wait_ms or on emac activity. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>inactive_interval_ms</parametername>
</parameternamelist>
<parameterdescription>
<para>: The interval for which the network is monitored for inactivity. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>inactive_window_ms</parametername>
</parameternamelist>
<parameterdescription>
<para>: The continuous duration for which network has to be inactive in inactive_interval_ms.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>int32_t : Returns status on one of these cases: Network error status if the network stack suspension failed or EMAC activity status as a result of network inactivity monitor. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-lpa/helpers/net_activity/network_activity_handler.h" line="181" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__lpautilities_1gab1bdee5b863d063b2cfb1dc693f8b685" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>int</type>
        <definition>int cy_tcp_create_socket_connection</definition>
        <argsstring>(void *net_intf, void **socket_handle, const char *remote_ip, uint16_t remote_port, uint16_t local_port, cy_tko_ol_cfg_t *downloaded, int socket_keepalive_enable)</argsstring>
        <name>cy_tcp_create_socket_connection</name>
        <param>
          <type>void *</type>
          <declname>net_intf</declname>
        </param>
        <param>
          <type>void **</type>
          <declname>socket_handle</declname>
        </param>
        <param>
          <type>const char *</type>
          <declname>remote_ip</declname>
        </param>
        <param>
          <type>uint16_t</type>
          <declname>remote_port</declname>
        </param>
        <param>
          <type>uint16_t</type>
          <declname>local_port</declname>
        </param>
        <param>
          <type><ref kindref="compound" refid="structcy__tko__ol__cfg__t">cy_tko_ol_cfg_t</ref> *</type>
          <declname>downloaded</declname>
        </param>
        <param>
          <type>int</type>
          <declname>socket_keepalive_enable</declname>
        </param>
        <briefdescription>
<para>Creates TCP Socket connection. </para>        </briefdescription>
        <detaileddescription>
<para>This function can be used as reference to create tcp socket connection to provided remote ip address, remote port, local port and the tcp socket handle is returned in *socket_handle</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>net_intf</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to WLAN interface </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>socket_handle</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to an Array of TCP Socket Handle which is populated by this API </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>remote_ip</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to Remote TCP IP Address </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>remote_port</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to Remote TCP IP Port number </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>local_port</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to Local TCP IP Port number </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>downloaded</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to TKO offload list </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>socket_keepalive_enable</parametername>
</parameternamelist>
<parameterdescription>
<para>: Host TCP Keepalive enable 1 or 0 disable. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>int : Returns CY_RSLT_SUCCESS if the TCP socket connection is successful, otherwise it returns a socket error status </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-lpa/helpers/net_activity/network_activity_handler.h" line="197" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__lpautilities_1ga2ebae1fd5c9c0e26363fc63b93bc9a83" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>int</type>
        <definition>int cylpa_restart_olm</definition>
        <argsstring>(ol_desc_t *offload_list, void *net_intf)</argsstring>
        <name>cylpa_restart_olm</name>
        <param>
          <type><ref kindref="compound" refid="structol__desc__t">ol_desc_t</ref> *</type>
          <declname>offload_list</declname>
        </param>
        <param>
          <type>void *</type>
          <declname>net_intf</declname>
        </param>
        <briefdescription>
<para>Restarts OLM. </para>        </briefdescription>
        <detaileddescription>
<para>This function restarts OLM manager with configuration passed by the caller. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;: This API should only be invoked when device is not connected to AP, if it is connected to an AP then it has to do disconnect first and then invoke this API&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>offload_list</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to the user defined configuration list <ref kindref="compound" refid="structol__desc__t">ol_desc_t</ref> </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>net_intf</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to WLAN interface </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>int : Returns CY_RSLT_SUCCESS if the restart is successful, otherwise it returns error. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-lpa/helpers/net_activity/network_activity_handler.h" line="211" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__lpautilities_1ga033b1135cd0d1b9c0ae63a2fc8764c1b" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="compound" refid="structol__desc__t">ol_desc_t</ref> *</type>
        <definition>ol_desc_t* cylpa_find_my_descriptor</definition>
        <argsstring>(const char *name, ol_desc_t *offload_list)</argsstring>
        <name>cylpa_find_my_descriptor</name>
        <param>
          <type>const char *</type>
          <declname>name</declname>
        </param>
        <param>
          <type><ref kindref="compound" refid="structol__desc__t">ol_desc_t</ref> *</type>
          <declname>offload_list</declname>
        </param>
        <briefdescription>
<para>Finds OLM descriptor for a given name. </para>        </briefdescription>
        <detaileddescription>
<para>This function finds the OLM descriptor for a given name passed by the caller in a OLM descriptor list.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>name</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to the string name of OLM descriptor </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>offload_list</parametername>
</parameternamelist>
<parameterdescription>
<para>: OLM descriptor list </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para><ref kindref="compound" refid="structol__desc__t">ol_desc_t</ref> : Returns OLM descriptor matching the name, otherwise it returns NULL </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-lpa/helpers/net_activity/network_activity_handler.h" line="222" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__lpautilities_1gaab3a675f4712ee9906da177610b0ca2a" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void *</type>
        <definition>void* cy_get_olm_instance</definition>
        <argsstring>(void)</argsstring>
        <name>cy_get_olm_instance</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
<para>Get OLM instance. </para>        </briefdescription>
        <detaileddescription>
<para>This function returns OLM instance <simplesect kind="return"><para><ref kindref="compound" refid="structolm__t">olm_t</ref> : Return OLM structure pointer </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-lpa/helpers/net_activity/network_activity_handler.h" line="230" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>The Documentation is provided for Network Utility functions used by the LPA application to demonstrate the Low power functionality. </para>    </briefdescription>
    <detaileddescription>

<para><heading level="1">Code Snippets</heading></para>

<para><bold>Code Snippet 1: Using wait_net_suspend for suspend/resume network stack</bold></para>
<para>The following code snippet demonstrates an example for Suspending Network stack to allow MCU to go to Deep Sleep. <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configures<sp />an<sp />emac<sp />activity<sp />callback<sp />to<sp />the<sp />Wi-Fi<sp />interface<sp />and</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />suspends<sp />the<sp />network<sp />if<sp />the<sp />network<sp />is<sp />inactive<sp />for<sp />a<sp />duration<sp />of</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />INACTIVE_WINDOW_MS<sp />inside<sp />an<sp />interval<sp />of<sp />INACTIVE_INTERVAL_MS.<sp />The</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />callback<sp />is<sp />used<sp />to<sp />signal<sp />the<sp />presence/absence<sp />of<sp />network<sp />activity</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />to<sp />resume/suspend<sp />the<sp />network<sp />stack.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">for</highlight><highlight class="normal"><sp />(;;)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__lpautilities_1ga8fe3dbb6666cb69c052385ce9ff9405f">wait_net_suspend</ref>(wifi,<sp />portMAX_DELAY,<sp />INACTIVE_INTERVAL_MS,<sp />INACTIVE_WINDOW_MS);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />vTaskDelay(pdMS_TO_TICKS(100));</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
</programlisting> </para>

<para><bold>Code Snippet 2: Read OLM configuration from device configurator.</bold></para>
<para>The following code snippet demonstrates an example for reading OLM configuration from device configurator and makes a local copy of the list. <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />...</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structolm__t">olm_t</ref><sp />*olm_inst<sp />=<sp />NULL;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structol__desc__t">ol_desc_t</ref>*<sp />dev_cfg_list<sp />=<sp />NULL;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />olm_inst<sp />=<sp /><ref kindref="member" refid="group__lpautilities_1gaab3a675f4712ee9906da177610b0ca2a">cy_get_olm_instance</ref>();</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<sp />olm_inst<sp />!=<sp />NULL<sp />)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />make<sp />a<sp />copy<sp />to<sp />local<sp />list<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />dev_cfg_list<sp />=<sp />(<ref kindref="compound" refid="structol__desc__t">ol_desc_t</ref><sp />*)olm_inst-&gt;<ref kindref="member" refid="structolm__t_1a2b190f623aefb6f3c6e51cc62b751789">ol_list</ref>;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />...</highlight></codeline>
</programlisting> </para>

<para><bold>Code Snippet 3: Search for TCP KA offload in the device configurator list.</bold></para>
<para>The following code snippet demonstrates an example for searching the "TKO" string in the device configurator list and if not present it add manual TCP KA offload configuration. <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />...</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tmp<sp />=<sp /><ref kindref="member" refid="group__lpautilities_1ga033b1135cd0d1b9c0ae63a2fc8764c1b">cylpa_find_my_descriptor</ref><sp />(<sp /></highlight><highlight class="stringliteral">"ARP"</highlight><highlight class="normal">,<sp />dev_cfg_list);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<sp />tmp<sp />!=<sp />NULL<sp />)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />i++;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tmp<sp />=<sp /><ref kindref="member" refid="group__lpautilities_1ga033b1135cd0d1b9c0ae63a2fc8764c1b">cylpa_find_my_descriptor</ref><sp />(</highlight><highlight class="stringliteral">"PKT_Filter"</highlight><highlight class="normal">,<sp />dev_cfg_list<sp />);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<sp />tmp<sp />!=<sp />NULL<sp />)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />i++;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tmp<sp />=<sp /><ref kindref="member" refid="group__lpautilities_1ga033b1135cd0d1b9c0ae63a2fc8764c1b">cylpa_find_my_descriptor</ref><sp />(<sp /></highlight><highlight class="stringliteral">"TKO"</highlight><highlight class="normal">,<sp />dev_cfg_list<sp />);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<sp />tmp<sp />==<sp />NULL<sp />)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />ADD<sp />TKO<sp />to<sp />list<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />dev_cfg_list<sp />=<sp />(<ref kindref="compound" refid="structcy__tko__ol__cfg__t">cy_tko_ol_cfg_t</ref><sp />*)tmp-&gt;<ref kindref="member" refid="structol__desc__t_1ae2465ecd5a2e0acd0dc6977405542194">cfg</ref>;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />dev_cfg_list[i].<ref kindref="member" refid="structol__desc__t_1aa710e639017abd5fa8b0bf08f255935f">name</ref><sp /><sp />=<sp /></highlight><highlight class="stringliteral">"TKO"</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />dev_cfg_list[i].<ref kindref="member" refid="structol__desc__t_1ae2465ecd5a2e0acd0dc6977405542194">cfg</ref><sp /><sp /><sp />=<sp />&amp;tko_new_cfgs[0];</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />dev_cfg_list[i].<ref kindref="member" refid="structol__desc__t_1a38e8e98322cb9bf5373cb635a3a4e58a">fns</ref><sp /><sp /><sp />=<sp />&amp;tko_ol_fns;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />dev_cfg_list[i].<ref kindref="member" refid="structol__desc__t_1a34c59e179d655f125e8613c0136f97ce">ol</ref><sp /><sp /><sp /><sp />=<sp />&amp;tko_ctxt;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />...</highlight></codeline>
</programlisting> </para>

<para><bold>Code Snippet 4: Use cylpa_restart_olm when the OLM configuration is changed by the user application.</bold></para>
<para>The following code snippet demonstrates an example for Restarting OLM interface with user defined configuration. <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp />....</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />disconnect<sp />to<sp />ap<sp />if<sp />connnected<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__lpautilities_1ga2ebae1fd5c9c0e26363fc63b93bc9a83">cylpa_restart_olm</ref>(dev_cfg_list,<sp />netwk_intf);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp />....</highlight></codeline>
</programlisting> </para>

<para><bold>Code Snippet 5: Use cy_tcp_create_socket_connection to offload TCP Keep-alive to WiFi Firmware</bold></para>
<para>The following code snippet demonstrates an example for creating TCP connection(s) and offloads TCP keep-alive when host MCU enters sleep/deepsleep via wait_net_suspend API call. <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />...</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">for</highlight><highlight class="normal"><sp />(</highlight><highlight class="keywordtype">int</highlight><highlight class="normal"><sp />index<sp />=<sp />0;<sp />index<sp />&lt;<sp />MAX_TKO;<sp />index++)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Establish<sp />TCP<sp />connection<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />response<sp />=<sp /><sp /><ref kindref="member" refid="group__lpautilities_1gab1bdee5b863d063b2cfb1dc693f8b685">cy_tcp_create_socket_connection</ref>(netwk_intf,<sp />(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />**)&amp;glob_socket[index],<sp />remote_ip[index],</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />remote_port[index],<sp />local_port[index],<sp />tko_new_cfgs,<sp />tcp_keealive_flag);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />....</highlight></codeline>
</programlisting> </para>

<para><bold>Code Snippet 6: Read OLM configuration from device configurator.</bold></para>
<para>The following code snippet demonstrates an example for reading OLM configuration from device configurator and makes a local copy of the list. <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />...</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*olm_inst<sp />=<sp />NULL;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structol__desc__t">ol_desc_t</ref>*<sp />dev_cfg_list<sp />=<sp />NULL;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />olm_inst<sp />=<sp /><ref kindref="member" refid="group__lpautilities_1gaab3a675f4712ee9906da177610b0ca2a">cy_get_olm_instance</ref>();</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<sp />olm_inst<sp />!=<sp />NULL<sp />)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />make<sp />a<sp />copy<sp />to<sp />local<sp />list<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />dev_cfg_list<sp />=<sp />(<ref kindref="compound" refid="structol__desc__t">ol_desc_t</ref><sp />*)get_default_ol_list();</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />...</highlight></codeline>
</programlisting></para>

    </detaileddescription>
  </compounddef>
</doxygen>